local BotList = BotList or CreateFrame("Frame", "BotList", UIParent)
-- Set MBH background texture
local ListTexture = BotList:CreateTexture(nil, "BACKGROUND")
ListTexture:SetTexture("Interface/Icons/inv_chest_cloth_54")
ListTexture:SetAllPoints()
-- Set MBH position properties
BotList:SetMovable(true)
BotList:EnableMouse(true)
BotList:SetClampedToScreen(true)
BotList:SetPoint("CENTER", nil, "CENTER", 0, 0)
BotList:SetWidth(100)
BotList:SetHeight(100)
BotList:Hide()
-- Allow players to move MBH with right click
BotList:RegisterForDrag("RightButton")
BotList:SetScript("OnDragStart", BotList.StartMoving)
BotList:SetScript("OnDragStop", BotList.StopMovingOrSizing)

-- Events that can cause this addon to update
BotList:RegisterEvent("UNIT_ENTERED_VEHICLE")
BotList:RegisterEvent("UNIT_EXITED_VEHICLE")

local frame = {}
function eventHandler(self, event, ...)
	-- Depopulate the list of players in vehicles
	if event == "UNIT_EXITED_VEHICLE" then
		for i=1,table.getn(frame) do
			frame[i]:Hide()
			BotList:Hide()
		end
	end
	-- Populate the list of players in vehicles
	for i=1,GetNumGroupMembers() do
		unit = select(1, GetRaidRosterInfo(i))
		if UnitInVehicle(unit) then
			frame[i] = frame[1] or CreateFrame("Button", "Frame", BotList)
			frame[i]:SetText(unit)
			frame[i]:SetNormalFontObject("GameFontNormalLarge")
			frame[i]:SetPoint("TOPLEFT", BotList, "TOPLEFT", -15, (i-1)*-25-1)
			frame[i]:SetWidth(90)
			frame[i]:SetHeight(25)
			frame[i]:SetScript("OnClick", function(self)
                TargetUnit(self:GetText(), true)
            end)
			frame[i]:Show()
			BotList:SetHeight(i*26+1)
			BotList:Show()
		end
	end
end
BotList:SetScript("OnEvent", eventHandler)