local icons = {"redwrench", "purplechicken", "greenspring", "yellowbolt", "bluegear"}
local botSpells = {"286152", "286192", "286215", "286219", "286226"}
local buttonFrame = {}
local buttonTexture = {}
local prefix = "jehsMBH"

-- Register prefix for chat communication, print message if it fails.
if not C_ChatInfo.RegisterAddonMessagePrefix(prefix) then
	message("PREFIX REGISTRATION ERROR: " .. prefix .. " NOT REGISTERED!")
end

-- Create popup frame to display icon when information is received
local infoFrame = infoFrame or CreateFrame("Frame", "InfoFrame", UIParent)
local infoTexture = infoTexture or infoFrame:CreateTexture(nil, "OVERLAY")
infoTexture:SetTexture("Interface/Icons/ability_vanish")
infoTexture:SetAllPoints()
infoFrame:SetMovable(false)
infoFrame:EnableMouse(true)
infoFrame:SetClampedToScreen(true)
infoFrame:SetPoint("CENTER", nil, "CENTER", 0, 150)
infoFrame:SetWidth(200)
infoFrame:SetHeight(200)
infoFrame:Hide()

-- Create background frame for anchoring buttons
local backgroundFrame = backgroundFrame or CreateFrame("Frame", "ButtonBackgroundFrame", UIParent)
local backgroundTexture = backgroundTexture or backgroundFrame:CreateTexture(nil, "BACKGROUND")
backgroundTexture:SetTexture("Interface/Icons/ability_vanish")
backgroundTexture:SetAllPoints()
backgroundFrame:SetMovable(true)
backgroundFrame:EnableMouse(true)
backgroundFrame:SetClampedToScreen(true)
backgroundFrame:SetPoint("TOPLEFT", nil, "TOPLEFT", 0, 0)
backgroundFrame:RegisterForDrag("RightButton")
backgroundFrame:SetScript("OnDragStart", backgroundFrame.StartMoving)
backgroundFrame:SetScript("OnDragStop", backgroundFrame.StopMovingOrSizing)
backgroundFrame:SetWidth(135)
backgroundFrame:SetHeight(35)
backgroundFrame:RegisterEvent("CHAT_MSG_ADDON")
backgroundFrame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
backgroundFrame:RegisterEvent("UNIT_EXITED_VEHICLE")

-- Create buttons to send information to partner
for i=1,5 do
	buttonFrame[i] = buttonFrame[i] or CreateFrame("Button", "ButtonFrame", ButtonBackgroundFrame)
	buttonTexture[i] = buttonTexture[i] or buttonFrame[i]:CreateTexture(nil, "BACKGROUND")
	buttonTexture[i]:SetTexture("Interface/Icons/spell_mekkatorque_bot_" .. icons[i])
	buttonTexture[i]:SetAllPoints()
	buttonFrame[i]:SetText(unit)
	buttonFrame[i]:SetPoint("TOPLEFT", ButtonBackgroundFrame, "TOPLEFT", (i-1)*25+5, -5)
	buttonFrame[i]:SetWidth(25)
	buttonFrame[i]:SetHeight(25)
	buttonFrame[i]:SetScript("OnClick", function(self)
		C_ChatInfo.SendAddonMessage(prefix, icons[i], "WHISPER", GetUnitName("target", true))
	end)
end

-- Receive events and handle them
local function eventHandler(self, event, arg1, arg2, arg3)
	-- When the event is a message from partner, pop up texture to show which button to push
	if event == "CHAT_MSG_ADDON" then
		if arg1 == prefix then
			infoTexture:SetTexture("Interface/Icons/spell_mekkatorque_bot_" .. arg2)
			infoFrame:Show()
		end
	-- When the event shows that you used any of the five bot options hide the information frame
	elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
		if arg1 == "player" then
			for i=1,5 do
				if arg3 == botSpells[i] then
					infoFrame:Hide()
				end
			end
		end
	-- When the player runs out of time, hide the information frame
	elseif event == "UNIT_EXITED_VEHICLE" then
		if arg1 == "player" then
			infoFrame:Hide()
		end
	end
end
backgroundFrame:SetScript("OnEvent", eventHandler)